from utilities.dcmgeometrysdk.dcmgeometry.polygons import PolygonGeom
import shapely.wkb as swkb
import shapely.geometry as sg
import shapely.ops as so
# polygon is ORM object from sqlalchemy


def create_polygons(polygon, points=None):
    polygons = []
    geometry = swkb.loads(polygon.geom.desc, hex=True)
    if isinstance(geometry, sg.Polygon):
        geometry = sg.MultiPolygon([geometry])
    if isinstance(geometry, sg.MultiPolygon):
        p = PolygonGeom()
        crs = polygon.geom.srid
        name = polygon.spi
        if len(geometry.geoms) == 1:
            geom = geometry.geoms[0]
            p.create_polygon(geom, points, name, crs)
        else:
            p.geom = None
            p.multipart = True
            for g in geometry.geoms:
                c = PolygonGeom()
                name = p.name + '_' + geometry.geoms.index(g)
                c.create_polygon(g, points, name, p.crs)
                c.parent = p.name
                p.part = True
                p.children.append(c.name)
                polygons.append(c)
        polygons.append(p)

    return polygons
